
public class Parh4 {
	public static void main(String[] args) throws InterruptedException {
		Bankszamla bankszamla = new Bankszamla();

		Thread t1 = new Thread(() -> {
			for (int i = 0; i < 1000000; i++) {
				bankszamla.betesz(1);
			}
		});
		t1.start();

		Thread t2 = new Thread(() -> {
			for (int i = 0; i < 1000000; i++) {
				bankszamla.kivesz(1);
			}
		});
		t2.start();
		
		Thread t3 = new Thread(() -> {
			for (int i = 0; i < 1000; i++) {
				System.out.println(bankszamla.get());
			}
		});
		t3.start();
		
		t1.join();
		t2.join();
		t3.join();

		System.out.println(bankszamla.get());
	}
}

class Bankszamla {
	private int osszeg = 0;

	public void betesz(int osszeg) {
		synchronized (this) {
			this.osszeg += osszeg;
		}
	}
	
	public synchronized void kivesz(int osszeg) {
//	public void kivesz(int osszeg) {
		this.osszeg -= osszeg;
	}

	public synchronized int get() {
//	public int get() {
		return osszeg;
	}
}
